package Debian::PkgJs::SimpleAudit;

use strict;
use Debian::PkgJs::Utils;
use Debian::PkgJs::Version;
use HTTP::Request::Common;
use LWP::UserAgent;
use Exporter 'import';
use JSON;

our @EXPORT = ( '&advisories' );

sub advisories {
    my ($path) = pop;
    my ( $name, $version ) =
      ( pjson($path)->{name}, pjson($path)->{version} // '*' );
    my $data = qq["$name":"$version"];
    my $data =
qq[{"name":"npm_audit_test","version":"1.0","requires":{$data},"dependencies":{"$name":{"version":"$version"}}}];
    my $req = HTTP::Request->new( 'POST',
        'https://registry.npmjs.org/-/npm/v1/security/audits' );
    $req->header( 'Content-Type' => 'application/json' );
    $req->content($data);
    my $resp = LWP::UserAgent->new()->request($req);
    my $res  = '';

    if ( $resp->is_success ) {
        my $json = eval { JSON::from_json( $resp->decoded_content ) };
        my $count = 0;
        if ( $json ) {
            foreach my $adv ( keys %{ $json->{advisories} } ) {
                my $c = $json->{advisories}->{$adv};
                $res .= "$name $c->{vulnerable_versions}
Severity: $c->{severity}
$c->{title} - $c->{url}

";
            $count ++;
            }
            $res .= "found $count vulnerabilities\n";
        }

        #print "RES: " . $res->decoded_content . "\n";
    }
    return $res;
}

1;
